window.Gleam.initSearch([{"doc":"pngleam","title":"pngleam","content":"# pngleam\n\n[![Package Version](https://img.shields.io/hexpm/v/pngleam)](https://hex.pm/packages/pngleam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/pngleam/)\n\n```sh\ngleam add pngleam\n```\n```gleam\nimport pngleam\n\npub fn main() {\n  [\n    &lt;&lt;0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0xFF&gt;&gt;,\n    &lt;&lt;0xFF, 0xFF, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0x00, 0xFF&gt;&gt;,\n    &lt;&lt;0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0x80, 0x80, 0x80&gt;&gt;,\n  ]\n  |&gt; pngleam.from_packed(\n    width: 3,\n    height: 3,\n    color_info: pngleam.rgb_8bit,\n    compression_level: pngleam.default_compression,\n  )\n  |&gt; simplifile.write_bits(&quot;img.png&quot;, _)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/pngleam&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"pngleam","title":"BinaryRowData","content":"pub type BinaryRowData =\n  List(BitArray)\n\n\nSynonyms:\npngleam.BinaryRowData\npngleam BinaryRowData","url":"pngleam.html#BinaryRowData"},{"doc":"pngleam","title":"ColorInfo","content":"pub opaque type ColorInfo\n\n\nSynonyms:\npngleam.ColorInfo\npngleam ColorInfo","url":"pngleam.html#ColorInfo"},{"doc":"pngleam","title":"ColorType","content":"pub type ColorType {\n  Greyscale\n  Color\n  Indexed\n  GreyscaleWithAlpha\n  ColorWithAlpha\n}\n\nGreyscale\n\n\nColor\n\n\nIndexed\n\n\nGreyscaleWithAlpha\n\n\nColorWithAlpha\n\n\nSynonyms:\npngleam.ColorType\npngleam ColorType","url":"pngleam.html#ColorType"},{"doc":"pngleam","title":"ColorValue","content":"pub type ColorValue =\n  #(Int, Int, Int)\n\n\nSynonyms:\npngleam.ColorValue\npngleam ColorValue","url":"pngleam.html#ColorValue"},{"doc":"pngleam","title":"ColorWithAlphaValue","content":"pub type ColorWithAlphaValue =\n  #(Int, Int, Int, Int)\n\n\nSynonyms:\npngleam.ColorWithAlphaValue\npngleam ColorWithAlphaValue","url":"pngleam.html#ColorWithAlphaValue"},{"doc":"pngleam","title":"CompressionLevel","content":"pub type CompressionLevel =\n  gzlib.CompressionLevel\n\n\nSynonyms:\npngleam.CompressionLevel\npngleam CompressionLevel","url":"pngleam.html#CompressionLevel"},{"doc":"pngleam","title":"FilterType","content":"pub type FilterType {\n  None\n  Sub\n  Up\n  Average\n  Paeth\n}\n\nNone\n\n\nSub\n\n\nUp\n\n\nAverage\n\n\nPaeth\n\n\nSynonyms:\npngleam.FilterType\npngleam FilterType","url":"pngleam.html#FilterType"},{"doc":"pngleam","title":"GreyscaleValue","content":"pub type GreyscaleValue =\n  Int\n\n\nSynonyms:\npngleam.GreyscaleValue\npngleam GreyscaleValue","url":"pngleam.html#GreyscaleValue"},{"doc":"pngleam","title":"GreyscaleWithAlphaValue","content":"pub type GreyscaleWithAlphaValue =\n  #(Int, Int)\n\n\nSynonyms:\npngleam.GreyscaleWithAlphaValue\npngleam GreyscaleWithAlphaValue","url":"pngleam.html#GreyscaleWithAlphaValue"},{"doc":"pngleam","title":"Grid","content":"pub type Grid(a) =\n  List(List(a))\n\n\nSynonyms:\npngleam.Grid\npngleam Grid","url":"pngleam.html#Grid"},{"doc":"pngleam","title":"PaletteColor","content":"pub type PaletteColor =\n  #(Int, Int, Int)\n\n\nSynonyms:\npngleam.PaletteColor\npngleam PaletteColor","url":"pngleam.html#PaletteColor"},{"doc":"pngleam","title":"PaletteColors","content":"pub type PaletteColors =\n  List(PaletteColor)\n\n\nSynonyms:\npngleam.PaletteColors\npngleam PaletteColors","url":"pngleam.html#PaletteColors"},{"doc":"pngleam","title":"PalleteIndex","content":"pub type PalleteIndex =\n  Int\n\n\nSynonyms:\npngleam.PalleteIndex\npngleam PalleteIndex","url":"pngleam.html#PalleteIndex"},{"doc":"pngleam","title":"ParseError","content":"pub type ParseError {\n  InvalidSignature\n  InvalidChunkTag\n  ChecksumMismatch\n  InvalidChunkOrder\n  MissingHeaderChunk\n  InvalidChunkData\n  InvalidColorType\n  InvalidBitDepth\n  InvalidCompressionType\n  InvalidFilterMethod\n  InvalidInterlaceMethod\n  UnsupportedInterlaceMethod\n  InvalidRowFilterType\n  InvalidRowData\n}\n\nInvalidSignature\n\n\nInvalidChunkTag\n\n\nChecksumMismatch\n\n\nInvalidChunkOrder\n\n\nMissingHeaderChunk\n\n\nInvalidChunkData\n\n\nInvalidColorType\n\n\nInvalidBitDepth\n\n\nInvalidCompressionType\n\n\nInvalidFilterMethod\n\n\nInvalidInterlaceMethod\n\n\nUnsupportedInterlaceMethod\n\n\nInvalidRowFilterType\n\n\nInvalidRowData\n\n\nSynonyms:\npngleam.ParseError\npngleam ParseError","url":"pngleam.html#ParseError"},{"doc":"pngleam","title":"PixelData","content":"pub type PixelData {\n  GreyscaleData(Grid(GreyscaleValue))\n  ColorData(Grid(ColorValue))\n  IndexedData(Grid(PalleteIndex))\n  GreyscaleWithAlphaData(Grid(GreyscaleWithAlphaValue))\n  ColorWithAlphaData(Grid(ColorWithAlphaValue))\n}\n\nGreyscaleData(Grid(GreyscaleValue))\n\n\nColorData(Grid(ColorValue))\n\n\nIndexedData(Grid(PalleteIndex))\n\n\nGreyscaleWithAlphaData(Grid(GreyscaleWithAlphaValue))\n\n\nColorWithAlphaData(Grid(ColorWithAlphaValue))\n\n\nSynonyms:\npngleam.PixelData\npngleam PixelData","url":"pngleam.html#PixelData"},{"doc":"pngleam","title":"PngBitArrayData","content":"pub type PngBitArrayData =\n  PngData(RawPalette, BinaryRowData)\n\n\nSynonyms:\npngleam.PngBitArrayData\npngleam PngBitArrayData","url":"pngleam.html#PngBitArrayData"},{"doc":"pngleam","title":"PngData","content":"pub type PngData(p, i) {\n  PngData(\n    metadata: PngMetadata,\n    palette: option.Option(p),\n    image_data: i,\n  )\n}\n\nPngData(\n  metadata: PngMetadata,\n  palette: option.Option(p),\n  image_data: i,\n)\n\n\nSynonyms:\npngleam.PngData\npngleam PngData","url":"pngleam.html#PngData"},{"doc":"pngleam","title":"PngMetadata","content":"pub type PngMetadata {\n  PngMetadata(width: Int, height: Int, color_info: ColorInfo)\n}\n\nPngMetadata(width: Int, height: Int, color_info: ColorInfo)\n\n\nSynonyms:\npngleam.PngMetadata\npngleam PngMetadata","url":"pngleam.html#PngMetadata"},{"doc":"pngleam","title":"PngPixelData","content":"pub type PngPixelData =\n  PngData(PaletteColors, PixelData)\n\n\nSynonyms:\npngleam.PngPixelData\npngleam PngPixelData","url":"pngleam.html#PngPixelData"},{"doc":"pngleam","title":"RawPalette","content":"pub type RawPalette =\n  BitArray\n\n\nSynonyms:\npngleam.RawPalette\npngleam RawPalette","url":"pngleam.html#RawPalette"},{"doc":"pngleam","title":"compression_level","content":"pub const compression_level: fn(Int) -&gt;\n  Result(CompressionLevel, Nil)\n\nSynonyms:\npngleam.compression_level\npngleam compression_level","url":"pngleam.html#compression_level"},{"doc":"pngleam","title":"default_compression","content":"pub const default_compression: CompressionLevel\n\nSynonyms:\npngleam.default_compression\npngleam default_compression","url":"pngleam.html#default_compression"},{"doc":"pngleam","title":"greyscale_8bit","content":"pub const greyscale_8bit: ColorInfo\n\nSynonyms:\npngleam.greyscale_8bit\npngleam greyscale_8bit","url":"pngleam.html#greyscale_8bit"},{"doc":"pngleam","title":"max_compression","content":"pub const max_compression: CompressionLevel\n\nSynonyms:\npngleam.max_compression\npngleam max_compression","url":"pngleam.html#max_compression"},{"doc":"pngleam","title":"min_compression","content":"pub const min_compression: CompressionLevel\n\nSynonyms:\npngleam.min_compression\npngleam min_compression","url":"pngleam.html#min_compression"},{"doc":"pngleam","title":"no_compression","content":"pub const no_compression: CompressionLevel\n\nSynonyms:\npngleam.no_compression\npngleam no_compression","url":"pngleam.html#no_compression"},{"doc":"pngleam","title":"rgb_16bit","content":"pub const rgb_16bit: ColorInfo\n\nSynonyms:\npngleam.rgb_16bit\npngleam rgb_16bit","url":"pngleam.html#rgb_16bit"},{"doc":"pngleam","title":"rgb_8bit","content":"pub const rgb_8bit: ColorInfo\n\nSynonyms:\npngleam.rgb_8bit\npngleam rgb_8bit","url":"pngleam.html#rgb_8bit"},{"doc":"pngleam","title":"rgba_16bit","content":"pub const rgba_16bit: ColorInfo\n\nSynonyms:\npngleam.rgba_16bit\npngleam rgba_16bit","url":"pngleam.html#rgba_16bit"},{"doc":"pngleam","title":"rgba_8bit","content":"pub const rgba_8bit: ColorInfo\n\nSynonyms:\npngleam.rgba_8bit\npngleam rgba_8bit","url":"pngleam.html#rgba_8bit"},{"doc":"pngleam","title":"color_info","content":"pub fn color_info(\n  color_type color_type: ColorType,\n  bit_depth bit_depth: Int,\n) -&gt; Result(ColorInfo, Nil)\n\nSynonyms:\npngleam.color_info\npngleam color_info","url":"pngleam.html#color_info"},{"doc":"pngleam","title":"color_info_bits","content":"pub fn color_info_bits(color_info: ColorInfo) -&gt; Int\n\nSynonyms:\npngleam.color_info_bits\npngleam color_info_bits","url":"pngleam.html#color_info_bits"},{"doc":"pngleam","title":"filter_type_to_int","content":"pub fn filter_type_to_int(filter_type: FilterType) -&gt; Int\n\nSynonyms:\npngleam.filter_type_to_int\npngleam filter_type_to_int","url":"pngleam.html#filter_type_to_int"},{"doc":"pngleam","title":"from_packed","content":"pub fn from_packed(\n  row_data row_data: List(BitArray),\n  width width: Int,\n  height height: Int,\n  color_info color_info: ColorInfo,\n  compression_level compression_level: CompressionLevel,\n) -&gt; BitArray\n\nSynonyms:\npngleam.from_packed\npngleam from_packed","url":"pngleam.html#from_packed"},{"doc":"pngleam","title":"int_to_filter_type","content":"pub fn int_to_filter_type(\n  filter_type: Int,\n) -&gt; Result(FilterType, Nil)\n\nSynonyms:\npngleam.int_to_filter_type\npngleam int_to_filter_type","url":"pngleam.html#int_to_filter_type"},{"doc":"pngleam","title":"parse_metadata","content":"pub fn parse_metadata(\n  data: BitArray,\n) -&gt; Result(PngMetadata, ParseError)\n\nSynonyms:\npngleam.parse_metadata\npngleam parse_metadata","url":"pngleam.html#parse_metadata"},{"doc":"pngleam","title":"parse_to_bit_arrays","content":"pub fn parse_to_bit_arrays(\n  data: BitArray,\n) -&gt; Result(PngData(BitArray, List(BitArray)), ParseError)\n\nSynonyms:\npngleam.parse_to_bit_arrays\npngleam parse_to_bit_arrays","url":"pngleam.html#parse_to_bit_arrays"},{"doc":"pngleam","title":"parse_to_pixel_data","content":"pub fn parse_to_pixel_data(\n  data: BitArray,\n) -&gt; Result(\n  PngData(List(#(Int, Int, Int)), PixelData),\n  ParseError,\n)\n\nSynonyms:\npngleam.parse_to_pixel_data\npngleam parse_to_pixel_data","url":"pngleam.html#parse_to_pixel_data"},{"doc":"pngleam","title":"pngleam","content":"","url":"pngleam.html"}]);